<script setup lang="ts">
import { reactive, ref, onMounted, toRaw, defineAsyncComponent } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { Modal, TableColumnsType, message } from 'ant-design-vue/es';
import { SizeType } from 'ant-design-vue/es/config-provider';
import { MenuInfo } from 'ant-design-vue/es/menu/src/interface';
import useNeInfoStore from '@/store/modules/neinfo';
import useI18n from '@/hooks/useI18n';
import { NE_TYPE_LIST } from '@/constants/ne-constants';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import { listNeSoftware, delNeSoftware } from '@/api/ne/neSoftware';
import { parseDateToStr } from '@/utils/date-utils';
import { downloadFile } from '@/api/tool/file';
import { saveAs } from 'file-saver';
const { t } = useI18n();

// 异步加载组件
const EditModal = defineAsyncComponent(
  () => import('./components/EditModal.vue')
);
const UploadMoreFile = defineAsyncComponent(
  () => import('./components/UploadMoreFile.vue')
);

/**网元参数 */
let neOtions = ref<Record<string, any>[]>([]);

/**查询参数 */
let queryParams = reactive({
  /**网元类型 */
  neType: undefined,
  /**包名称 */
  name: '',
  /**包版本 */
  version: '',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    neType: undefined,
    name: '',
    version: '',
    pageNum: 1,
    pageSize: 20,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
  /**勾选单行记录 */
  selectedRowOne: any;
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: false,
  data: [],
  selectedRowKeys: [],
  /**勾选单行记录 */
  selectedRowOne: { neType: '' },
});

/**表格字段列 */
let tableColumns = ref<TableColumnsType>([
  {
    title: t('common.rowId'),
    dataIndex: 'id',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.ne.common.neType'),
    dataIndex: 'neType',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.ne.neSoftware.version'),
    dataIndex: 'version',
    align: 'left',
    width: 150,
  },
  {
    title: t('views.ne.neSoftware.name'),
    dataIndex: 'name',
    align: 'left',
    width: 250,
    resizable: true,
    minWidth: 150,
    maxWidth: 400,
  },
  {
    title: t('common.description'),
    dataIndex: 'description',
    key: 'description',
    align: 'left',
    width: 200,
    resizable: true,
    minWidth: 100,
    maxWidth: 400,
  },
  {
    title: t('common.createTime'),
    dataIndex: 'createTime',
    align: 'center',
    customRender(opt) {
      if (!opt.value) return '';
      return parseDateToStr(opt.value);
    },
    width: 150,
  },
  {
    title: t('common.operate'),
    key: 'id',
    align: 'left',
  },
]);

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**表格多选 */
function fnTableSelectedRowKeys(
  keys: (string | number)[],
  selectedRows: any[]
) {
  tableState.selectedRowKeys = keys;
  // 勾选单个上传
  if (selectedRows.length === 1) {
    tableState.selectedRowOne = selectedRows[0];
  } else {
    tableState.selectedRowOne = { neType: '' };
  }
}

/**查询列表, pageNum初始页数 */
function fnGetList(pageNum?: number) {
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
  }
  listNeSoftware(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.rows)) {
      tablePagination.total = res.total;
      tableState.data = res.rows;
      if (
        tablePagination.total <=
          (queryParams.pageNum - 1) * tablePagination.pageSize &&
        queryParams.pageNum !== 1
      ) {
        tableState.loading = false;
        fnGetList(queryParams.pageNum - 1);
      }
    } else {
      tablePagination.total = 0;
      tableState.data = [];
    }
    tableState.loading = false;
  });
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**新增框或修改框是否显示 */
  openByEdit: boolean;
  /**新增框或修改框ID */
  editId: string;
  /**多文件上传 */
  openByMoreFile: boolean;
  /**确定按钮 loading */
  confirmLoading: boolean;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  openByEdit: false,
  editId: '',
  openByMoreFile: false,
  confirmLoading: false,
});

/**
 * 对话框弹出显示为 新增或者修改
 * @param noticeId 网元id, 不传为新增
 */
function fnModalVisibleByEdit(id?: string) {
  if (!id) {
    modalState.editId = '';
  } else {
    modalState.editId = id;
  }
  modalState.openByEdit = !modalState.openByEdit;
}

/**
 * 对话框弹出确认执行函数
 * 进行表达规则校验
 */
function fnModalEditOk() {
  fnGetList(1);
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalEditCancel() {
  modalState.editId = '';
  modalState.openByEdit = false;
  modalState.openByMoreFile = false;
}

/**删除软件包 */
function fnRecordDelete(id: string) {
  if (!id || modalState.confirmLoading) return;
  let msg = t('views.ne.neSoftware.delTip');
  if (id === '0') {
    msg = `${msg} ...${tableState.selectedRowKeys.length}`;
    id = tableState.selectedRowKeys.join(',');
  }

  Modal.confirm({
    title: t('common.tipTitle'),
    content: msg,
    onOk() {
      if (modalState.confirmLoading) return;
      modalState.confirmLoading = true;
      const hide = message.loading(t('common.loading'), 0);
      delNeSoftware(id)
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            // 获取列表数据
            fnGetList();
          } else {
            message.error(res.msg, 3);
          }
        })
        .finally(() => {
          modalState.confirmLoading = false;
          hide();
        });
    },
  });
}

/**下载软件包 */
function fnDownloadFile(row: Record<string, any>) {
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.ne.neSoftware.downTip', { txt: row.name }),
    onOk() {
      const hide = message.loading(t('common.loading'), 0);
      downloadFile(row.path)
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.operateOk'),
              duration: 2,
            });
            saveAs(res.data, `${row.name}`);
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 2,
            });
          }
        })
        .finally(() => {
          hide();
        });
    },
  });
}

/**
 * 记录更多操作
 */
function fnRecordMore(type: string | number, row: Record<string, any>) {
  if (type === 'download') {
    fnDownloadFile(row);
    return;
  }
  if (type === 'delete') {
    fnRecordDelete(row.id);
    return;
  }
}

onMounted(() => {
  // 获取网元网元列表
  useNeInfoStore()
    .fnNelist()
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
        neOtions.value = useNeInfoStore().getNeSelectOtions;
      } else {
        message.warning({
          content: t('common.noData'),
          duration: 2,
        });
      }
    })
    .finally(() => {
      // 获取列表数据
      fnGetList();
    });
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item :label="t('views.ne.common.neType')" name="neType ">
              <a-auto-complete
                v-model:value="queryParams.neType"
                :options="NE_TYPE_LIST.map(v => ({ value: v }))"
                allow-clear
                :placeholder="t('common.inputPlease')"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item :label="t('views.ne.neSoftware.name')" name="name">
              <a-input
                v-model:value="queryParams.name"
                allow-clear
                :placeholder="t('common.inputPlease')"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.ne.neSoftware.version')"
              name="version"
            >
              <a-input
                v-model:value="queryParams.version"
                allow-clear
                :placeholder="t('common.inputPlease')"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList(1)">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-space :size="8" align="center">
          <a-button type="primary" @click.prevent="fnModalVisibleByEdit()">
            <template #icon><UploadOutlined /></template>
            {{ t('views.ne.neSoftware.upload') }}
          </a-button>
          <a-button
            type="primary"
            :disabled="tableState.selectedRowKeys.length > 1"
            @click.prevent="
              () => (modalState.openByMoreFile = !modalState.openByMoreFile)
            "
          >
            <template #icon><UploadOutlined /></template>
            <template v-if="tableState.selectedRowOne.neType">
              {{ t('views.ne.neSoftware.upload') }}
              {{ tableState.selectedRowOne.neType }}
            </template>
            <template v-else>
              {{ t('views.ne.neSoftware.uploadBatch') }}
            </template>
          </a-button>
          <a-button
            type="default"
            danger
            :disabled="tableState.selectedRowKeys.length <= 0"
            :loading="modalState.confirmLoading"
            @click.prevent="fnRecordDelete('0')"
          >
            <template #icon><DeleteOutlined /></template>
            {{ t('common.deleteText') }}
          </a-button>
        </a-space>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown placement="bottomRight" trigger="click">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">
                    {{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle">
                    {{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small">
                    {{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="id"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: tableColumns.length * 150 }"
        @resizeColumn="(w:number, col:any) => (col.width = w)"
        :row-selection="{
          type: 'checkbox',
          columnWidth: '48px',
          selectedRowKeys: tableState.selectedRowKeys,
          onChange: fnTableSelectedRowKeys,
        }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'description'">
            <a-tooltip placement="topLeft">
              <template #title>{{ record.description }}</template>
              <div
                style="
                  overflow: hidden;
                  text-overflow: ellipsis;
                  white-space: nowrap;
                  cursor: pointer;
                  width: 50px;
                "
                :style="{ width: column.width + 'px' }"
              >
                {{ record.description }}
              </div>
            </a-tooltip>
          </template>
          <template v-if="column.key === 'id'">
            <a-space :size="8" align="center">
              <a-tooltip placement="topRight">
                <template #title> {{ t('common.editText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalVisibleByEdit(record.id)"
                >
                  <template #icon> <ProfileOutlined /></template>
                </a-button>
              </a-tooltip>

              <a-tooltip placement="left">
                <template #title>{{ t('common.moreText') }}</template>
                <a-dropdown placement="bottomRight" trigger="click">
                  <a-button type="link">
                    <template #icon><EllipsisOutlined /> </template>
                  </a-button>
                  <template #overlay>
                    <a-menu @click="({ key }:any) => fnRecordMore(key, record)">
                      <a-menu-item key="download">
                        <DownloadOutlined />
                        {{ t('common.downloadText') }}
                      </a-menu-item>
                      <a-menu-item key="delete">
                        <DeleteOutlined />
                        {{ t('common.deleteText') }}
                      </a-menu-item>
                    </a-menu>
                  </template>
                </a-dropdown>
              </a-tooltip>
            </a-space>
          </template>
        </template>
      </a-table>
    </a-card>

    <!-- 新增框或修改框 -->
    <EditModal
      v-model:open="modalState.openByEdit"
      :edit-id="modalState.editId"
      @ok="fnModalEditOk"
      @cancel="fnModalEditCancel"
    ></EditModal>

    <!-- 新增多文件上传框 -->
    <UploadMoreFile
      v-model:open="modalState.openByMoreFile"
      :ne-type="tableState.selectedRowOne.neType"
      @ok="fnModalEditOk"
      @cancel="fnModalEditCancel"
    ></UploadMoreFile>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
